package  top.autopc.listen_call

import spCallbackHandleEventName
import android.content.Context
import android.telephony.PhoneStateListener
import android.telephony.ServiceState
import android.util.Log
import backgroundServiceSharedPreferencesName
import deviceNameArgumentKey
import io.flutter.plugin.common.MethodChannel
import onCallPhoneCallMethod

private const val TAG="CPSL";
/**
 * 来去电监听
 */
class CallPhoneListener(mContext: Context, private val backgroundChannel: MethodChannel) : PhoneStateListener() {
    private val  sharedPreferences=mContext.getSharedPreferences(backgroundServiceSharedPreferencesName,Context.MODE_PRIVATE);
    override fun onServiceStateChanged(serviceState: ServiceState) {
        super.onServiceStateChanged(serviceState)
        Log.d(TAG,"CustomPhoneStateListener onServiceStateChanged: $serviceState")
    }

    override fun onCallStateChanged(state: Int, incomingNumber: String) {
        super.onCallStateChanged(state, incomingNumber);
        Log.d(TAG, "CustomPhoneStateListener state: "+ state + " incomingNumber: " + incomingNumber)
        val spCallbackHandleEventID=sharedPreferences.getLong(spCallbackHandleEventName,0)
        val deviceName=sharedPreferences.getString(deviceNameArgumentKey,"");
        backgroundChannel.invokeMethod(
                onCallPhoneCallMethod,
                hashMapOf(
                        "state" to state,
                        "incomingNumber" to incomingNumber,
                        "callback" to spCallbackHandleEventID,
                        "deviceName" to deviceName,
                )
        )
    }
}